﻿Type=Class
Version=4.2
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@

Sub Class_Globals
	Private fx As JFX
	Private MainForm As Form
	Private DragCoords As Map
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Owner As Form)
	MainForm.Initialize("MainForm", 200, 200)
	MainForm.SetOwner(Owner)
	MainForm.BackColor = fx.Colors.Transparent
	MainForm.SetFormStyle("TRANSPARENT")
	MainForm.RootPane.Style = $"-fx-background-color:red;-fx-background-radius:48px;"$
	MainForm.RootPane.MouseCursor = fx.Cursors.HAND

	Dim btn As Button
	btn.Initialize("btn")
	btn.Text = $"Close modal form"$
	MainForm.RootPane.AddNode(btn, 25, 25, -1, -1)

	MainForm.ShowAndWait	
End Sub

Sub btn_Action
	Log($"Close modal form"$)
	MainForm.Close
End Sub

Sub MainForm_MousePressed (EventData As MouseEvent)
	DragCoords = CreateMap("x":EventData.X, "y":EventData.Y)
End Sub

Sub MainForm_MouseDragged (EventData As MouseEvent)
	Dim joEventData As JavaObject = EventData
	Dim mouseX As Double = joEventData.RunMethod("getScreenX", Null)
	Dim mouseY As Double = joEventData.RunMethod("getScreenY", Null)

	MainForm.WindowLeft = mouseX - DragCoords.Get("x")
	MainForm.WindowTop = mouseY - DragCoords.Get("y")	
End Sub


